module VerifyExamples.ZipperPull.Create2 exposing (..)

-- This file got generated by [elm-verify-examples](https://github.com/stoeffel/elm-verify-examples).
-- Please don't modify this file by hand!

import Test
import Expect

import ZipperPull exposing (..)

type alias Model =
    { title : String
    , readCount : Int
    , previousVolumes : List (String, Int)
    , latterVolumes : List (String, Int)
    }

pull : ZipperPull (String, Int) Model output
pull =
    create
        { getForeList = .latterVolumes
        , getRearList = .previousVolumes
        , getCurrent = \m -> (m.title, m.readCount)
        , setForeList = \l m -> {m| latterVolumes = l}
        , setRearList = \f m -> {m| previousVolumes = f}
        , setCurrent = \(t,c) m -> {m| title=t, readCount=c}
        }
model : Model
model =
    { title = "Philosopher's Stone"
    , readCount = 3
    , previousVolumes = []
    , latterVolumes =
        [ ("Chamber of Secrets",2)
        , ("Prisoner of Azkaban",2)
        , ("Goblet of Fire",3)
        , ("Order of the Phoenix",2)
        , ("Half-Blood Prince",1)
        , ("Deathly Hallows",1)
        ]
    }



spec2 : Test.Test
spec2 =
    Test.test "#create: \n\n    model\n        |> pull.foldFromFirst\n            (\\(title, count) str ->\n                str\n                ++ \"I have read \\\"\"\n                ++ title\n                ++ \"\\\" \"\n                ++ String.fromInt count\n                ++ \" times. \"\n            )\n            \"\"\n    --> \"I have read \\\"Philosopher's Stone\\\" 3 times. \" ++ \"I have read \\\"Chamber of Secrets\\\" 2 times. \" ++ \"I have read \\\"Prisoner of Azkaban\\\" 2 times. \" ++ \"I have read \\\"Goblet of Fire\\\" 3 times. \" ++ \"I have read \\\"Order of the Phoenix\\\" 2 times. \" ++ \"I have read \\\"Half-Blood Prince\\\" 1 times. \" ++ \"I have read \\\"Deathly Hallows\\\" 1 times. \"" <|
        \() ->
            Expect.equal
                (
                model
                    |> pull.foldFromFirst
                        (\(title, count) str ->
                            str
                            ++ "I have read \""
                            ++ title
                            ++ "\" "
                            ++ String.fromInt count
                            ++ " times. "
                        )
                        ""
                )
                (
                "I have read \"Philosopher's Stone\" 3 times. " ++ "I have read \"Chamber of Secrets\" 2 times. " ++ "I have read \"Prisoner of Azkaban\" 2 times. " ++ "I have read \"Goblet of Fire\" 3 times. " ++ "I have read \"Order of the Phoenix\" 2 times. " ++ "I have read \"Half-Blood Prince\" 1 times. " ++ "I have read \"Deathly Hallows\" 1 times. "
                )